"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

const object_entries_1 = __importDefault(require("object.entries"));

const lodash_includes_1 = __importDefault(require("lodash.includes"));

const isJson_1 = __importDefault(require("./isJson"));

let delimiterSeperatedArray;
/**
 * Make a json file into a delimiter seperated string.
 * It will push everything into the global delimiterSeperatedArray
 */

const jsonConcat = (json, options, jsonString) => {
  object_entries_1.default(json).forEach(entryArray => {
    const key = entryArray[0];
    const value = entryArray[1];
    let generatedJsonString;
    let typeOfString = typeof value; // convert arrays from object to array

    if (Array.isArray(value)) {
      typeOfString = 'array';
    }

    if (jsonString) {
      // if the objects are nested, jsonString is not empty
      generatedJsonString = jsonString + options.delimiter + key;
    } else {
      // for the first object for loop
      generatedJsonString = key;
    }

    if (options.type.length === 0 || lodash_includes_1.default(options.type, typeOfString)) {
      delimiterSeperatedArray.push(generatedJsonString);
    }

    if (typeOfString === 'array' && Array.isArray(value)) {
      // arrays should iterate over single values and add it to the global delimiterSeperatedArray
      value.forEach(item => {
        if (options.type.length === 0 || lodash_includes_1.default(options.type, typeof item)) {
          delimiterSeperatedArray.push(generatedJsonString + options.delimiter + item);
        }
      });
    } else if (typeOfString === 'object') {
      // objects should just recursivly call the function
      jsonConcat(value, options, generatedJsonString);
    }
  });
};

const chain = (json, options = {}) => {
  const newOptions = Object.assign({
    type: [],
    delimiter: '/'
  }, options);
  delimiterSeperatedArray = [];

  if (!isJson_1.default(json)) {
    return [];
  }

  jsonConcat(json, newOptions);
  return delimiterSeperatedArray;
};

exports.default = chain;