"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

const lodash_includes_1 = __importDefault(require("lodash.includes"));

const find = (jsonObject, findString, options = {}) => {
  const newOptions = Object.assign({
    type: [],
    max: -1
  }, options);
  newOptions.type = Array.isArray(newOptions.type) ? newOptions.type : [newOptions.type];
  let resultArray = []; // eslint-disable-next-line

  for (const key in jsonObject) {
    const value = jsonObject[key];

    if (key === findString) {
      let typeOfString = typeof value; // convert arrays from object to array

      if (Object.prototype.toString.call(value) === '[object Array]') {
        typeOfString = 'array';
      } // add if either
      // all are allowed => empty array or
      // if the specific type is in option.type


      if (newOptions.type.length === 0 || lodash_includes_1.default(newOptions.type, typeOfString)) {
        resultArray.push({
          key: findString,
          type: typeOfString,
          data: value
        });

        if (newOptions.max !== -1 && resultArray.length === newOptions.max) {
          return resultArray;
        }
      }
    } // recursive if it is an object


    if (Object.prototype.toString.call(value) === '[object Object]') {
      const recursiveArray = find(value, findString, newOptions);
      resultArray = [...resultArray, ...recursiveArray];

      if (newOptions.max !== -1 && resultArray.length >= newOptions.max) {
        return resultArray;
      }
    }
  }

  return resultArray;
};

exports.default = find;