"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

const fs_extra_1 = __importDefault(require("fs-extra"));

const isJsonString_1 = __importDefault(require("./isJsonString"));

const readToObj = async path => {
  // search for file. Fail fast if there is no json File
  if (!fs_extra_1.default.existsSync(path) || !fs_extra_1.default.statSync(path).isFile()) {
    throw new Error();
  }

  const data = await fs_extra_1.default.readFile(path, 'utf8');

  if (!isJsonString_1.default(data)) {
    throw new Error('JSON is not valid');
  }

  const strToObj = JSON.parse(data);
  return strToObj;
};

exports.default = readToObj;