"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

const fs_1 = __importDefault(require("fs"));

const isJsonString_1 = __importDefault(require("./isJsonString"));

const readToObjSync = path => {
  // search for file. Fail fast if there is no json File
  if (!fs_1.default.existsSync(path) || !fs_1.default.statSync(path).isFile()) {
    return false;
  }

  const fileString = fs_1.default.readFileSync(path, 'utf8');

  if (!isJsonString_1.default(fileString)) {
    return false;
  }

  const strToObj = JSON.parse(fileString);
  return strToObj;
};

exports.default = readToObjSync;