"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

const fs_extra_1 = __importDefault(require("fs-extra"));

const path_1 = __importDefault(require("path"));

const isJsonString_1 = __importDefault(require("./isJsonString"));

const write = async (pathString, filename, content = '{}') => {
  let thisContent = content;
  let thisFilename = filename;

  if (path_1.default.extname(thisFilename) !== '.json') {
    const nameCache = thisFilename;
    thisFilename = `${path_1.default.basename(nameCache, path_1.default.extname(nameCache))}.json`;
  }

  const combinePath = path_1.default.join(pathString, thisFilename);

  if (typeof thisContent === 'object') {
    thisContent = JSON.stringify(thisContent);
  }

  if (typeof thisContent !== 'string' || !isJsonString_1.default(thisContent)) {
    throw new Error('JSON is not valid');
  }

  await fs_extra_1.default.ensureDir(pathString);
  await fs_extra_1.default.writeFile(combinePath, thisContent, 'utf8');
};

exports.default = write;