"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

const fs_extra_1 = __importDefault(require("fs-extra"));

const path_1 = __importDefault(require("path"));

const isJsonString_1 = __importDefault(require("./isJsonString")); // eslint-disable-next-line @typescript-eslint/no-explicit-any


const writeSync = (pathString, filename, content) => {
  const combinePath = path_1.default.join(pathString, filename);
  let thisContent = content;
  thisContent = typeof thisContent === 'undefined' ? '{}' : thisContent;

  if (typeof thisContent === 'object') {
    thisContent = JSON.stringify(thisContent);
  }

  if (typeof thisContent !== 'string') return false;
  if (!isJsonString_1.default(thisContent)) return false;
  fs_extra_1.default.ensureDirSync(pathString);
  fs_extra_1.default.writeFileSync(combinePath, thisContent, 'utf8');
  return true;
};

exports.default = writeSync;